import pygame
import time
import random
 
pygame.init()

display_width = 800
display_height = 600
 
black = (0,0,0)
white = (255,255,255)

red = (200,0,0)
green = (0,200,0)

bright_red = (255,0,0)
bright_green = (0,255,0)
 
block_color = (53,115,255)
 
car_width = 73
 
gameDisplay = pygame.display.set_mode((display_width,display_height))
pygame.display.set_caption('Racing video game')
clock = pygame.time.Clock()
 
carImg = pygame.image.load('car.png')
gameIcon = pygame.image.load('icon.png')

pygame.display.set_icon(gameIcon)

pause = False
#crash = True
 
def enemies_dodged(count):
    font = pygame.font.SysFont("verdana", 25)
    text = font.render("Score: "+str(count), True, black)
    gameDisplay.blit(text,(0,0))
 
def enemies(enemyx, enemyy, enemyw, enemyh, color):
    pygame.draw.rect(gameDisplay, color, [enemyx, enemyy, enemyw, enemyh])
 
def car(x,y):
    gameDisplay.blit(carImg,(x,y))
 
def text_objects(text, font):
    textSurface = font.render(text, True, black)
    return textSurface, textSurface.get_rect()
 
def crash():
    largeText = pygame.font.SysFont("verdana",115)
    TextSurf, TextRect = text_objects("Game Over!", largeText)
    TextRect.center = ((display_width/2),(display_height/2))
    gameDisplay.blit(TextSurf, TextRect)

    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                quit()
                
        button("Restart",150,450,100,50,green,bright_green,game_loop)
        button("Exit",550,450,100,50,red,bright_red,quitgame)

        pygame.display.update()
        clock.tick(15) 

def button(msg,x,y,w,h,ic,ac,action=None):
    mouse = pygame.mouse.get_pos()
    click = pygame.mouse.get_pressed()

    if x+w > mouse[0] > x and y+h > mouse[1] > y:
        pygame.draw.rect(gameDisplay, ac,(x,y,w,h))
        if click[0] == 1 and action != None:
            action()         
    else:
        pygame.draw.rect(gameDisplay, ic,(x,y,w,h))
    smallText = pygame.font.SysFont("verdana",20)
    textSurf, textRect = text_objects(msg, smallText)
    textRect.center = ( (x+(w/2)), (y+(h/2)) )
    gameDisplay.blit(textSurf, textRect)
    
def quitgame():
    pygame.quit()
    quit()

def unpause():
    global pause
    pygame.mixer.music.unpause()
    pause = False
    
def paused():
    largeText = pygame.font.SysFont("verdana",115)
    TextSurf, TextRect = text_objects("Game Paused", largeText)
    TextRect.center = ((display_width/2),(display_height/2))
    gameDisplay.blit(TextSurf, TextRect)
    
    while pause:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                quit()

        button("Continue",150,450,100,50,green,bright_green,unpause)
        button("Exit",550,450,100,50,red,bright_red,quitgame)

        pygame.display.update()
        clock.tick(15)   

def game_intro():

    intro = True

    while intro:
        for event in pygame.event.get():
            #print(event)
            if event.type == pygame.QUIT:
                pygame.quit()
                quit()
                
        gameDisplay.fill(white)
        largeText = pygame.font.SysFont("verdana",65)
        TextSurf, TextRect = text_objects("Racing video game", largeText)
        TextRect.center = ((display_width/2),(display_height/2))
        gameDisplay.blit(TextSurf, TextRect)

        button("Start",150,450,100,50,green,bright_green,game_loop)
        button("Exit",550,450,100,50,red,bright_red,quitgame)

        pygame.display.update()
        clock.tick(15)
         
def game_loop():
    global pause
    x = (display_width * 0.45)
    y = (display_height * 0.8)
    x_change = 0
    enemy_startx = random.randrange(0, display_width)
    enemy_starty = -600
    enemy_speed = 4
    enemy_width = 100
    enemy_height = 100
    enemyCount = 1
    dodged = 0
    gameExit = False
 
    while not gameExit:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                quit()
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_LEFT:
                    x_change = -5
                if event.key == pygame.K_RIGHT:
                    x_change = 5
                if event.key == pygame.K_p:
                    pause = True
                    paused()    
            if event.type == pygame.KEYUP:
                if event.key == pygame.K_LEFT or event.key == pygame.K_RIGHT:
                    x_change = 0
 
        x += x_change
        gameDisplay.fill(white)
 
        enemies(enemy_startx, enemy_starty, enemy_width, enemy_height, block_color)
        
        enemy_starty += enemy_speed
        car(x,y)
        enemies_dodged(dodged)
 
        if x > display_width - car_width or x < 0:
            crash()
        if enemy_starty > display_height:
            enemy_starty = 0 - enemy_height
            enemy_startx = random.randrange(0,display_width)
            dodged += 1
            enemy_speed += 1
            enemy_width += (dodged * 1.2)
        if y < enemy_starty+enemy_height:
            #print('Collision detected on y axis')
            if x > enemy_startx and x < enemy_startx + enemy_width or x+car_width > enemy_startx and x + car_width < enemy_startx+enemy_width:
                #print('Collision detected on x axis')
                crash()
        
        pygame.display.update()
        clock.tick(60)

game_intro()
game_loop()
pygame.quit()
quit()